diff --git a/sys/dev/netif/ath/ath/if_ath_tx.c b/sys/dev/netif/ath/ath/if_ath_tx.c
index bc225f1..e61cae7 100644
--- a/sys/dev/netif/ath/ath/if_ath_tx.c
+++ b/sys/dev/netif/ath/ath/if_ath_tx.c
@@ -739,21 +739,37 @@ ath_tx_handoff_hw(struct ath_softc *sc, struct ath_txq *txq,
 	     ("ath_tx_handoff_hw called for mcast queue"));
 
 	/*
-	 * XXX We should instead just verify that sc_txstart_cnt
-	 * or ath_txproc_cnt > 0.  That would mean that
-	 * the reset is going to be waiting for us to complete.
+	 * XXX racy, should hold the PCU lock when checking this,
+	 * and also should ensure that the TX counter is >0!
 	 */
-	if (sc->sc_txproc_cnt == 0 && sc->sc_txstart_cnt == 0) {
-		device_printf(sc->sc_dev,
-		    "%s: TX dispatch without holding txcount/txstart refcnt!\n",
-		    __func__);
-	}
+	KASSERT((sc->sc_inreset_cnt == 0),
+	    ("%s: TX during reset?\n", __func__));
 
+#if 0
 	/*
-	 * XXX .. this is going to cause the hardware to get upset;
-	 * so we really should find some way to drop or queue
-	 * things.
+	 * This causes a LOR. Find out where the PCU lock is being
+	 * held whilst the TXQ lock is grabbed - that shouldn't
+	 * be occuring.
 	 */
+	ATH_PCU_LOCK(sc);
+	if (sc->sc_inreset_cnt) {
+		ATH_PCU_UNLOCK(sc);
+		DPRINTF(sc, ATH_DEBUG_RESET,
+		    "%s: called with sc_in_reset != 0\n",
+		    __func__);
+		DPRINTF(sc, ATH_DEBUG_XMIT,
+		    "%s: queued: TXDP[%u] = %p (%p) depth %d\n",
+		    __func__, txq->axq_qnum,
+		    (caddr_t)bf->bf_daddr, bf->bf_desc,
+		    txq->axq_depth);
+		/* XXX axq_link needs to be set and updated! */
+		ATH_TXQ_INSERT_TAIL(txq, bf, bf_list);
+		if (bf->bf_state.bfs_aggr)
+			txq->axq_aggr_depth++;
+		return;
+		}
+	ATH_PCU_UNLOCK(sc);
+#endif
 
 	ATH_TXQ_LOCK(txq);
 
@@ -1578,7 +1594,6 @@ ath_tx_normal_setup(struct ath_softc *sc, struct ieee80211_node *ni,
 	error = ath_tx_dmasetup(sc, bf, m0);
 	if (error != 0)
 		return error;
-	KASSERT((ni != NULL), ("%s: ni=NULL!", __func__));
 	bf->bf_node = ni;			/* NB: held reference */
 	m0 = bf->bf_m;				/* NB: may have changed */
 	wh = mtod(m0, struct ieee80211_frame *);
@@ -2070,7 +2085,6 @@ ath_tx_raw_start(struct ath_softc *sc, struct ieee80211_node *ni,
 	int do_override;
 	uint8_t type, subtype;
 	int queue_to_head;
-	struct ath_node *an = ATH_NODE(ni);
 
 	ATH_TX_LOCK_ASSERT(sc);
 
@@ -2130,7 +2144,6 @@ ath_tx_raw_start(struct ath_softc *sc, struct ieee80211_node *ni,
 		return error;
 	m0 = bf->bf_m;				/* NB: may have changed */
 	wh = mtod(m0, struct ieee80211_frame *);
-	KASSERT((ni != NULL), ("%s: ni=NULL!", __func__));
 	bf->bf_node = ni;			/* NB: held reference */
 
 	/* Always enable CLRDMASK for raw frames for now.. */
@@ -2149,24 +2162,12 @@ ath_tx_raw_start(struct ath_softc *sc, struct ieee80211_node *ni,
 
 	rt = sc->sc_currates;
 	KASSERT(rt != NULL, ("no rate table, mode %u", sc->sc_curmode));
-
-	/* Fetch first rate information */
 	rix = ath_tx_findrix(sc, params->ibp_rate0);
-	try0 = params->ibp_try0;
-
-	/*
-	 * Override EAPOL rate as appropriate.
-	 */
-	if (m0->m_flags & M_EAPOL) {
-		/* XXX? maybe always use long preamble? */
-		rix = an->an_mgmtrix;
-		try0 = ATH_TXMAXTRY;	/* XXX?too many? */
-	}
-
 	txrate = rt->info[rix].rateCode;
 	if (params->ibp_flags & IEEE80211_BPF_SHORTPRE)
 		txrate |= rt->info[rix].shortPreamble;
 	sc->sc_txrix = rix;
+	try0 = params->ibp_try0;
 	ismrr = (params->ibp_try1 != 0);
 	txantenna = params->ibp_pri >> 2;
 	if (txantenna == 0)			/* XXX? */
@@ -2239,7 +2240,8 @@ ath_tx_raw_start(struct ath_softc *sc, struct ieee80211_node *ni,
 	/* Blank the legacy rate array */
 	bzero(&bf->bf_state.bfs_rc, sizeof(bf->bf_state.bfs_rc));
 
-	bf->bf_state.bfs_rc[0].rix = rix;
+	bf->bf_state.bfs_rc[0].rix =
+	    ath_tx_findrix(sc, params->ibp_rate0);
 	bf->bf_state.bfs_rc[0].tries = try0;
 	bf->bf_state.bfs_rc[0].ratecode = txrate;
 
@@ -2331,14 +2333,11 @@ ath_raw_xmit(struct ieee80211_node *ni, struct mbuf *m,
 		    "%s: sc_inreset_cnt > 0; bailing\n", __func__);
 		error = EIO;
 		ATH_PCU_UNLOCK(sc);
-		goto badbad;
+		goto bad0;
 	}
 	sc->sc_txstart_cnt++;
 	ATH_PCU_UNLOCK(sc);
 
-	/* Wake the hardware up already */
-	ath_power_set_power_state(sc, HAL_PM_AWAKE);
-
 	ATH_TX_LOCK(sc);
 
 	if ((ifp->if_flags & IFF_RUNNING) == 0 || sc->sc_invalid) {
@@ -2417,12 +2416,7 @@ ath_raw_xmit(struct ieee80211_node *ni, struct mbuf *m,
 	sc->sc_txstart_cnt--;
 	ATH_PCU_UNLOCK(sc);
 
-
-	/* Put the hardware back to sleep if required */
-	ath_power_restore_power_state(sc);
-
 	return 0;
-
 bad2:
 	ATH_KTR(sc, ATH_KTR_TX, 3, "ath_raw_xmit: bad2: m=%p, params=%p, "
 	    "bf=%p",
@@ -2432,18 +2426,14 @@ bad2:
 	ATH_TXBUF_LOCK(sc);
 	ath_returnbuf_head(sc, bf);
 	ATH_TXBUF_UNLOCK(sc);
-
 bad:
+
 	ATH_TX_UNLOCK(sc);
 
 	ATH_PCU_LOCK(sc);
 	sc->sc_txstart_cnt--;
 	ATH_PCU_UNLOCK(sc);
-
-	/* Put the hardware back to sleep if required */
-	ath_power_restore_power_state(sc);
-
-badbad:
+bad0:
 	ATH_KTR(sc, ATH_KTR_TX, 2, "ath_raw_xmit: bad0: m=%p, params=%p",
 	    m, params);
 	ifp->if_oerrors++;
@@ -2739,8 +2729,8 @@ ath_tx_update_baw(struct ath_softc *sc, struct ath_node *an,
 		INCR(tid->baw_head, ATH_TID_MAX_BUFS);
 	}
 	DPRINTF(sc, ATH_DEBUG_SW_TX_BAW,
-	    "%s: tid=%d: baw is now %d:%d, baw head=%d\n",
-	    __func__, tid->tid, tap->txa_start, tap->txa_wnd, tid->baw_head);
+	    "%s: baw is now %d:%d, baw head=%d\n",
+	    __func__, tap->txa_start, tap->txa_wnd, tid->baw_head);
 }
 
 static void
@@ -3232,11 +3222,8 @@ ath_tx_tid_pause(struct ath_softc *sc, struct ath_tid *tid)
 
 	ATH_TX_LOCK_ASSERT(sc);
 	tid->paused++;
-	DPRINTF(sc, ATH_DEBUG_SW_TX_CTRL, "%s: [%s]: tid=%d, paused = %d\n",
-	    __func__,
-	    ath_hal_ether_sprintf(tid->an->an_node.ni_macaddr),
-	    tid->tid,
-	    tid->paused);
+	DPRINTF(sc, ATH_DEBUG_SW_TX_CTRL, "%s: paused = %d\n",
+	    __func__, tid->paused);
 }
 
 /*
@@ -3253,22 +3240,15 @@ ath_tx_tid_resume(struct ath_softc *sc, struct ath_tid *tid)
 	 * until it's actually resolved.
 	 */
 	if (tid->paused == 0) {
-		device_printf(sc->sc_dev,
-			      "%s: [%s]: tid=%d, paused=0?\n",
-			      __func__,
-			      ath_hal_ether_sprintf(
-						tid->an->an_node.ni_macaddr),
-			      tid->tid);
+		DPRINTF(sc, ATH_DEBUG_SW_TX_CTRL,
+		    "%s: %s: paused=0?\n", __func__,
+		    ath_hal_ether_sprintf(tid->an->an_node.ni_macaddr));
 	} else {
 		tid->paused--;
 	}
 
-	DPRINTF(sc, ATH_DEBUG_SW_TX_CTRL,
-	    "%s: [%s]: tid=%d, unpaused = %d\n",
-	    __func__,
-	    ath_hal_ether_sprintf(tid->an->an_node.ni_macaddr),
-	    tid->tid,
-	    tid->paused);
+	DPRINTF(sc, ATH_DEBUG_SW_TX_CTRL, "%s: unpaused = %d\n",
+	    __func__, tid->paused);
 
 	if (tid->paused)
 		return;
@@ -3334,8 +3314,8 @@ ath_tx_tid_filt_comp_buf(struct ath_softc *sc, struct ath_tid *tid,
 	ATH_TX_LOCK_ASSERT(sc);
 
 	if (! tid->isfiltered) {
-		DPRINTF(sc, ATH_DEBUG_SW_TX_FILT, "%s: tid=%d; filter transition\n",
-		    __func__, tid->tid);
+		DPRINTF(sc, ATH_DEBUG_SW_TX_FILT, "%s: filter transition\n",
+		    __func__);
 		tid->isfiltered = 1;
 		ath_tx_tid_pause(sc, tid);
 	}
@@ -3355,20 +3335,15 @@ static void
 ath_tx_tid_filt_comp_complete(struct ath_softc *sc, struct ath_tid *tid)
 {
 	struct ath_buf *bf;
-	int do_resume = 0;
 
 	ATH_TX_LOCK_ASSERT(sc);
 
 	if (tid->hwq_depth != 0)
 		return;
 
-	DPRINTF(sc, ATH_DEBUG_SW_TX_FILT, "%s: tid=%d, hwq=0, transition back\n",
-	    __func__, tid->tid);
-	if (tid->isfiltered == 1) {
-		tid->isfiltered = 0;
-		do_resume = 1;
-	}
-
+	DPRINTF(sc, ATH_DEBUG_SW_TX_FILT, "%s: hwq=0, transition back\n",
+	    __func__);
+	tid->isfiltered = 0;
 	/* XXX ath_tx_tid_resume() also calls ath_tx_set_clrdmask()! */
 	ath_tx_set_clrdmask(sc, tid->an);
 
@@ -3378,21 +3353,16 @@ ath_tx_tid_filt_comp_complete(struct ath_softc *sc, struct ath_tid *tid)
 		ATH_TID_INSERT_HEAD(tid, bf, bf_list);
 	}
 
-	/* And only resume if we had paused before */
-	if (do_resume)
-		ath_tx_tid_resume(sc, tid);
+	ath_tx_tid_resume(sc, tid);
 }
 
 /*
  * Called when a single (aggregate or otherwise) frame is completed.
  *
- * Returns 0 if the buffer could be added to the filtered list
- * (cloned or otherwise), 1 if the buffer couldn't be added to the
+ * Returns 1 if the buffer could be added to the filtered list
+ * (cloned or otherwise), 0 if the buffer couldn't be added to the
  * filtered list (failed clone; expired retry) and the caller should
  * free it and handle it like a failure (eg by sending a BAR.)
- *
- * since the buffer may be cloned, bf must be not touched after this
- * if the return value is 0.
  */
 static int
 ath_tx_tid_filt_comp_single(struct ath_softc *sc, struct ath_tid *tid,
@@ -3412,9 +3382,8 @@ ath_tx_tid_filt_comp_single(struct ath_softc *sc, struct ath_tid *tid,
 		    "%s: bf=%p, seqno=%d, exceeded retries\n",
 		    __func__,
 		    bf,
-		    SEQNO(bf->bf_state.bfs_seqno));
-		retval = 1; /* error */
-		goto finish;
+		    bf->bf_state.bfs_seqno);
+		return (0);
 	}
 
 	/*
@@ -3434,12 +3403,11 @@ ath_tx_tid_filt_comp_single(struct ath_softc *sc, struct ath_tid *tid,
 		DPRINTF(sc, ATH_DEBUG_SW_TX_FILT,
 		    "%s: busy buffer couldn't be cloned (%p)!\n",
 		    __func__, bf);
-		retval = 1; /* error */
+		retval = 1;
 	} else {
 		ath_tx_tid_filt_comp_buf(sc, tid, nbf);
-		retval = 0; /* ok */
+		retval = 0;
 	}
-finish:
 	ath_tx_tid_filt_comp_complete(sc, tid);
 
 	return (retval);
@@ -3464,11 +3432,10 @@ ath_tx_tid_filt_comp_aggr(struct ath_softc *sc, struct ath_tid *tid,
 		if (bf->bf_state.bfs_retries > SWMAX_RETRIES) {
 			sc->sc_stats.ast_tx_swretrymax++;
 			DPRINTF(sc, ATH_DEBUG_SW_TX_FILT,
-			    "%s: tid=%d, bf=%p, seqno=%d, exceeded retries\n",
+			    "%s: bf=%p, seqno=%d, exceeded retries\n",
 			    __func__,
-			    tid->tid,
 			    bf,
-			    SEQNO(bf->bf_state.bfs_seqno));
+			    bf->bf_state.bfs_seqno);
 			TAILQ_INSERT_TAIL(bf_q, bf, bf_list);
 			goto next;
 		}
@@ -3476,8 +3443,8 @@ ath_tx_tid_filt_comp_aggr(struct ath_softc *sc, struct ath_tid *tid,
 		if (bf->bf_flags & ATH_BUF_BUSY) {
 			nbf = ath_tx_retry_clone(sc, tid->an, tid, bf);
 			DPRINTF(sc, ATH_DEBUG_SW_TX_FILT,
-			    "%s: tid=%d, busy buffer cloned: %p -> %p, seqno=%d\n",
-			    __func__, tid->tid, bf, nbf, SEQNO(bf->bf_state.bfs_seqno));
+			    "%s: busy buffer cloned: %p -> %p",
+			    __func__, bf, nbf);
 		} else {
 			nbf = bf;
 		}
@@ -3488,8 +3455,8 @@ ath_tx_tid_filt_comp_aggr(struct ath_softc *sc, struct ath_tid *tid,
 		 */
 		if (nbf == NULL) {
 			DPRINTF(sc, ATH_DEBUG_SW_TX_FILT,
-			    "%s: tid=%d, buffer couldn't be cloned! (%p) seqno=%d\n",
-			    __func__, tid->tid, bf, SEQNO(bf->bf_state.bfs_seqno));
+			    "%s: buffer couldn't be cloned! (%p)\n",
+			    __func__, bf);
 			TAILQ_INSERT_TAIL(bf_q, bf, bf_list);
 		} else {
 			ath_tx_tid_filt_comp_buf(sc, tid, nbf);
@@ -3727,7 +3694,7 @@ ath_tx_tid_drain_print(struct ath_softc *sc, struct ath_node *an,
 	txq = sc->sc_ac2q[tid->ac];
 	tap = ath_tx_get_tx_tid(an, tid->tid);
 
-	DPRINTF(sc, ATH_DEBUG_SW_TX | ATH_DEBUG_RESET,
+	DPRINTF(sc, ATH_DEBUG_SW_TX,
 	    "%s: %s: %s: bf=%p: addbaw=%d, dobaw=%d, "
 	    "seqno=%d, retry=%d\n",
 	    __func__,
@@ -3738,7 +3705,7 @@ ath_tx_tid_drain_print(struct ath_softc *sc, struct ath_node *an,
 	    bf->bf_state.bfs_dobaw,
 	    SEQNO(bf->bf_state.bfs_seqno),
 	    bf->bf_state.bfs_retries);
-	DPRINTF(sc, ATH_DEBUG_SW_TX | ATH_DEBUG_RESET,
+	DPRINTF(sc, ATH_DEBUG_SW_TX,
 	    "%s: %s: %s: bf=%p: txq[%d] axq_depth=%d, axq_aggr_depth=%d\n",
 	    __func__,
 	    pfx,
@@ -3747,7 +3714,7 @@ ath_tx_tid_drain_print(struct ath_softc *sc, struct ath_node *an,
 	    txq->axq_qnum,
 	    txq->axq_depth,
 	    txq->axq_aggr_depth);
-	DPRINTF(sc, ATH_DEBUG_SW_TX | ATH_DEBUG_RESET,
+	DPRINTF(sc, ATH_DEBUG_SW_TX,
 	    "%s: %s: %s: bf=%p: tid txq_depth=%d hwq_depth=%d, bar_wait=%d, "
 	      "isfiltered=%d\n",
 	    __func__,
@@ -3758,7 +3725,7 @@ ath_tx_tid_drain_print(struct ath_softc *sc, struct ath_node *an,
 	    tid->hwq_depth,
 	    tid->bar_wait,
 	    tid->isfiltered);
-	DPRINTF(sc, ATH_DEBUG_SW_TX | ATH_DEBUG_RESET,
+	DPRINTF(sc, ATH_DEBUG_SW_TX,
 	    "%s: %s: %s: tid %d: "
 	    "sched=%d, paused=%d, "
 	    "incomp=%d, baw_head=%d, "
@@ -3773,10 +3740,9 @@ ath_tx_tid_drain_print(struct ath_softc *sc, struct ath_node *an,
 	     ni->ni_txseqs[tid->tid]);
 
 	/* XXX Dump the frame, see what it is? */
-	if (IFF_DUMPPKTS(sc, ATH_DEBUG_XMIT))
-		ieee80211_dump_pkt(ni->ni_ic,
-		    mtod(bf->bf_m, const uint8_t *),
-		    bf->bf_m->m_len, 0, -1);
+	ieee80211_dump_pkt(ni->ni_ic,
+	    mtod(bf->bf_m, const uint8_t *),
+	    bf->bf_m->m_len, 0, -1);
 }
 
 /*
@@ -3817,7 +3783,7 @@ ath_tx_tid_drain(struct ath_softc *sc, struct ath_node *an,
 
 		if (t == 0) {
 			ath_tx_tid_drain_print(sc, an, "norm", tid, bf);
-//			t = 1;
+			t = 1;
 		}
 
 		ATH_TID_REMOVE(tid, bf, bf_list);
@@ -3833,7 +3799,7 @@ ath_tx_tid_drain(struct ath_softc *sc, struct ath_node *an,
 
 		if (t == 0) {
 			ath_tx_tid_drain_print(sc, an, "filt", tid, bf);
-//			t = 1;
+			t = 1;
 		}
 
 		ATH_TID_FILT_REMOVE(tid, bf, bf_list);
@@ -4088,19 +4054,6 @@ ath_tx_normal_comp(struct ath_softc *sc, struct ath_buf *bf, int fail)
 		DPRINTF(sc, ATH_DEBUG_SW_TX, "%s: hwq_depth < 0: %d\n",
 		    __func__, atid->hwq_depth);
 
-	/* If the TID is being cleaned up, track things */
-	/* XXX refactor! */
-	if (atid->cleanup_inprogress) {
-		atid->incomp--;
-		if (atid->incomp == 0) {
-			DPRINTF(sc, ATH_DEBUG_SW_TX_CTRL,
-			    "%s: TID %d: cleaned up! resume!\n",
-			    __func__, tid);
-			atid->cleanup_inprogress = 0;
-			ath_tx_tid_resume(sc, atid);
-		}
-	}
-
 	/*
 	 * If the queue is filtered, potentially mark it as complete
 	 * and reschedule it as needed.
@@ -4148,16 +4101,6 @@ ath_tx_comp_cleanup_unaggr(struct ath_softc *sc, struct ath_buf *bf)
 
 	ATH_TX_LOCK(sc);
 	atid->incomp--;
-
-	/* XXX refactor! */
-	if (bf->bf_state.bfs_dobaw) {
-		ath_tx_update_baw(sc, an, atid, bf);
-		if (!bf->bf_state.bfs_addedbaw)
-			DPRINTF(sc, ATH_DEBUG_SW_TX,
-			    "%s: wasn't added: seqno %d\n",
-			    __func__, SEQNO(bf->bf_state.bfs_seqno));
-	}
-
 	if (atid->incomp == 0) {
 		DPRINTF(sc, ATH_DEBUG_SW_TX_CTRL,
 		    "%s: TID %d: cleaned up! resume!\n",
@@ -4170,72 +4113,14 @@ ath_tx_comp_cleanup_unaggr(struct ath_softc *sc, struct ath_buf *bf)
 	ath_tx_default_comp(sc, bf, 0);
 }
 
-
-/*
- * This as it currently stands is a bit dumb.  Ideally we'd just
- * fail the frame the normal way and have it permanently fail
- * via the normal aggregate completion path.
- */
-static void
-ath_tx_tid_cleanup_frame(struct ath_softc *sc, struct ath_node *an,
-    int tid, struct ath_buf *bf_head, ath_bufhead *bf_cq)
-{
-	struct ath_tid *atid = &an->an_tid[tid];
-	struct ath_buf *bf, *bf_next;
-
-	ATH_TX_LOCK_ASSERT(sc);
-
-	/*
-	 * Remove this frame from the queue.
-	 */
-	ATH_TID_REMOVE(atid, bf_head, bf_list);
-
-	/*
-	 * Loop over all the frames in the aggregate.
-	 */
-	bf = bf_head;
-	while (bf != NULL) {
-		bf_next = bf->bf_next;	/* next aggregate frame, or NULL */
-
-		/*
-		 * If it's been added to the BAW we need to kick
-		 * it out of the BAW before we continue.
-		 *
-		 * XXX if it's an aggregate, assert that it's in the
-		 * BAW - we shouldn't have it be in an aggregate
-		 * otherwise!
-		 */
-		if (bf->bf_state.bfs_addedbaw) {
-			ath_tx_update_baw(sc, an, atid, bf);
-			bf->bf_state.bfs_dobaw = 0;
-		}
-
-		/*
-		 * Give it the default completion handler.
-		 */
-		bf->bf_comp = ath_tx_normal_comp;
-		bf->bf_next = NULL;
-
-		/*
-		 * Add it to the list to free.
-		 */
-		TAILQ_INSERT_TAIL(bf_cq, bf, bf_list);
-
-		/*
-		 * Now advance to the next frame in the aggregate.
-		 */
-		bf = bf_next;
-	}
-}
-
 /*
  * Performs transmit side cleanup when TID changes from aggregated to
- * unaggregated and during reassociation.
+ * unaggregated.
  *
- * For now, this just tosses everything from the TID software queue
- * whether or not it has been retried and marks the TID as
- * pending completion if there's anything for this TID queued to
- * the hardware.
+ * - Discard all retry frames from the s/w queue.
+ * - Fix the tx completion function for all buffers in s/w queue.
+ * - Count the number of unacked frames, and let transmit completion
+ *   handle it later.
  *
  * The caller is responsible for pausing the TID and unpausing the
  * TID if no cleanup was required. Otherwise the cleanup path will
@@ -4246,19 +4131,18 @@ ath_tx_tid_cleanup(struct ath_softc *sc, struct ath_node *an, int tid,
     ath_bufhead *bf_cq)
 {
 	struct ath_tid *atid = &an->an_tid[tid];
+	struct ieee80211_tx_ampdu *tap;
 	struct ath_buf *bf, *bf_next;
 
 	ATH_TX_LOCK_ASSERT(sc);
 
 	DPRINTF(sc, ATH_DEBUG_SW_TX_BAW,
-	    "%s: TID %d: called; inprogress=%d\n", __func__, tid,
-	    atid->cleanup_inprogress);
+	    "%s: TID %d: called\n", __func__, tid);
 
 	/*
 	 * Move the filtered frames to the TX queue, before
 	 * we run off and discard/process things.
 	 */
-
 	/* XXX this is really quite inefficient */
 	while ((bf = ATH_TID_FILT_LAST(atid, ath_bufhead_s)) != NULL) {
 		ATH_TID_FILT_REMOVE(atid, bf, bf_list);
@@ -4273,35 +4157,47 @@ ath_tx_tid_cleanup(struct ath_softc *sc, struct ath_node *an, int tid,
 	 */
 	bf = ATH_TID_FIRST(atid);
 	while (bf) {
-		/*
-		 * Grab the next frame in the list, we may
-		 * be fiddling with the list.
-		 */
-		bf_next = TAILQ_NEXT(bf, bf_list);
-
-		/*
-		 * Free the frame and all subframes.
-		 */
-		ath_tx_tid_cleanup_frame(sc, an, tid, bf, bf_cq);
-
-		/*
-		 * Next frame!
-		 */
-		bf = bf_next;
+		if (bf->bf_state.bfs_isretried) {
+			bf_next = TAILQ_NEXT(bf, bf_list);
+			ATH_TID_REMOVE(atid, bf, bf_list);
+			if (bf->bf_state.bfs_dobaw) {
+				ath_tx_update_baw(sc, an, atid, bf);
+				if (!bf->bf_state.bfs_addedbaw)
+					DPRINTF(sc, ATH_DEBUG_SW_TX_BAW,
+					    "%s: wasn't added: seqno %d\n",
+					    __func__,
+					    SEQNO(bf->bf_state.bfs_seqno));
+			}
+			bf->bf_state.bfs_dobaw = 0;
+			/*
+			 * Call the default completion handler with "fail" just
+			 * so upper levels are suitably notified about this.
+			 */
+			TAILQ_INSERT_TAIL(bf_cq, bf, bf_list);
+			bf = bf_next;
+			continue;
+		}
+		/* Give these the default completion handler */
+		bf->bf_comp = ath_tx_normal_comp;
+		bf = TAILQ_NEXT(bf, bf_list);
 	}
 
 	/*
-	 * If there's anything in the hardware queue we wait
-	 * for the TID HWQ to empty.
+	 * Calculate what hardware-queued frames exist based
+	 * on the current BAW size. Ie, what frames have been
+	 * added to the TX hardware queue for this TID but
+	 * not yet ACKed.
 	 */
-	if (atid->hwq_depth > 0) {
-		/*
-		 * XXX how about we kill atid->incomp, and instead
-		 * replace it with a macro that checks that atid->hwq_depth
-		 * is 0?
-		 */
-		atid->incomp = atid->hwq_depth;
-		atid->cleanup_inprogress = 1;
+	tap = ath_tx_get_tx_tid(an, tid);
+	/* Need the lock - fiddling with BAW */
+	while (atid->baw_head != atid->baw_tail) {
+		if (atid->tx_buf[atid->baw_head]) {
+			atid->incomp++;
+			atid->cleanup_inprogress = 1;
+			atid->tx_buf[atid->baw_head] = NULL;
+		}
+		INCR(atid->baw_head, ATH_TID_MAX_BUFS);
+		INCR(tap->txa_start, IEEE80211_SEQ_RANGE);
 	}
 
 	if (atid->cleanup_inprogress)
@@ -4634,19 +4530,9 @@ ath_tx_comp_cleanup_aggr(struct ath_softc *sc, struct ath_buf *bf_first)
 	ATH_TX_LOCK(sc);
 
 	/* update incomp */
-	atid->incomp--;
-
-	/* Update the BAW */
 	bf = bf_first;
 	while (bf) {
-		/* XXX refactor! */
-		if (bf->bf_state.bfs_dobaw) {
-			ath_tx_update_baw(sc, an, atid, bf);
-			if (!bf->bf_state.bfs_addedbaw)
-				DPRINTF(sc, ATH_DEBUG_SW_TX,
-				    "%s: wasn't added: seqno %d\n",
-				    __func__, SEQNO(bf->bf_state.bfs_seqno));
-		}
+		atid->incomp--;
 		bf = bf->bf_next;
 	}
 
@@ -4669,11 +4555,10 @@ ath_tx_comp_cleanup_aggr(struct ath_softc *sc, struct ath_buf *bf_first)
 
 	ATH_TX_UNLOCK(sc);
 
-	/* Handle frame completion as individual frames */
+	/* Handle frame completion */
 	bf = bf_first;
 	while (bf) {
 		bf_next = bf->bf_next;
-		bf->bf_next = NULL;
 		ath_tx_default_comp(sc, bf, 1);
 		bf = bf_next;
 	}
@@ -5115,10 +5000,6 @@ ath_tx_aggr_comp_unaggr(struct ath_softc *sc, struct ath_buf *bf, int fail)
 			    "%s: isfiltered=1, fail=%d\n",
 			    __func__, fail);
 		freeframe = ath_tx_tid_filt_comp_single(sc, atid, bf);
-		/*
-		 * If freeframe=0 then bf is no longer ours; don't
-		 * touch it.
-		 */
 		if (freeframe) {
 			/* Remove from BAW */
 			if (bf->bf_state.bfs_addedbaw)
@@ -5154,6 +5035,7 @@ ath_tx_aggr_comp_unaggr(struct ath_softc *sc, struct ath_buf *bf, int fail)
 		if (freeframe)
 			ath_tx_default_comp(sc, bf, fail);
 
+
 		return;
 	}
 	/*
@@ -5858,26 +5740,12 @@ ath_addba_stop(struct ieee80211_node *ni, struct ieee80211_tx_ampdu *tap)
 	 */
 	TAILQ_INIT(&bf_cq);
 	ATH_TX_LOCK(sc);
-
+	ath_tx_tid_cleanup(sc, an, tid, &bf_cq);
 	/*
-	 * In case there's a followup call to this, only call it
-	 * if we don't have a cleanup in progress.
-	 *
-	 * Since we've paused the queue above, we need to make
-	 * sure we unpause if there's already a cleanup in
-	 * progress - it means something else is also doing
-	 * this stuff, so we don't need to also keep it paused.
+	 * Unpause the TID if no cleanup is required.
 	 */
-	if (atid->cleanup_inprogress) {
+	if (! atid->cleanup_inprogress)
 		ath_tx_tid_resume(sc, atid);
-	} else {
-		ath_tx_tid_cleanup(sc, an, tid, &bf_cq);
-		/*
-		 * Unpause the TID if no cleanup is required.
-		 */
-		if (! atid->cleanup_inprogress)
-			ath_tx_tid_resume(sc, atid);
-	}
 	ATH_TX_UNLOCK(sc);
 
 	/* Handle completing frames and fail them */
@@ -5911,24 +5779,18 @@ ath_tx_node_reassoc(struct ath_softc *sc, struct ath_node *an)
 		tid = &an->an_tid[i];
 		if (tid->hwq_depth == 0)
 			continue;
+		ath_tx_tid_pause(sc, tid);
 		DPRINTF(sc, ATH_DEBUG_NODE,
 		    "%s: %s: TID %d: cleaning up TID\n",
 		    __func__,
 		    ath_hal_ether_sprintf(an->an_node.ni_macaddr),
 		    i);
+		ath_tx_tid_cleanup(sc, an, i, &bf_cq);
 		/*
-		 * In case there's a followup call to this, only call it
-		 * if we don't have a cleanup in progress.
+		 * Unpause the TID if no cleanup is required.
 		 */
-		if (! tid->cleanup_inprogress) {
-			ath_tx_tid_pause(sc, tid);
-			ath_tx_tid_cleanup(sc, an, i, &bf_cq);
-			/*
-			 * Unpause the TID if no cleanup is required.
-			 */
-			if (! tid->cleanup_inprogress)
-				ath_tx_tid_resume(sc, tid);
-		}
+		if (! tid->cleanup_inprogress)
+			ath_tx_tid_resume(sc, tid);
 	}
 	ATH_TX_UNLOCK(sc);
 
@@ -5958,42 +5820,18 @@ ath_bar_response(struct ieee80211_node *ni, struct ieee80211_tx_ampdu *tap,
 	struct ath_node *an = ATH_NODE(ni);
 	struct ath_tid *atid = &an->an_tid[tid];
 	int attempts = tap->txa_attempts;
-	int old_txa_start;
 
 	DPRINTF(sc, ATH_DEBUG_SW_TX_BAR,
-	    "%s: %s: called; txa_tid=%d, atid->tid=%d, status=%d, attempts=%d"
-	    ",  txa_start=%d, txa_seqpending=%d\n",
+	    "%s: %s: called; txa_tid=%d, atid->tid=%d, status=%d, attempts=%d\n",
 	    __func__,
 	    ath_hal_ether_sprintf(ni->ni_macaddr),
 	    tap->txa_ac,
 	    atid->tid,
 	    status,
-	    attempts,
-	    tap->txa_start,
-	    tap->txa_seqpending);
+	    attempts);
 
 	/* Note: This may update the BAW details */
-	/*
-	 * XXX What if this does slide the BAW along? We need to somehow
-	 * XXX either fix things when it does happen, or prevent the
-	 * XXX seqpending value to be anything other than exactly what
-	 * XXX the hell we want!
-	 *
-	 * XXX So for now, how I do this inside the TX lock for now
-	 * XXX and just correct it afterwards? The below condition should
-	 * XXX never happen and if it does I need to fix all kinds of things.
-	 */
-	old_txa_start = tap->txa_start;
 	sc->sc_bar_response(ni, tap, status);
-	if (tap->txa_start != old_txa_start) {
-		device_printf(sc->sc_dev,
-			      "%s: tid=%d; txa_start=%d, old=%d, adjusting\n",
-			      __func__,
-			      tid,
-			      tap->txa_start,
-			      old_txa_start);
-	}
-	tap->txa_start = old_txa_start;
 
 	/* Unpause the TID */
 	/*
diff --git a/sys/dev/netif/ath/ath/if_athvar.h b/sys/dev/netif/ath/ath/if_athvar.h
index 8125877..3d609ec 100644
--- a/sys/dev/netif/ath/ath/if_athvar.h
+++ b/sys/dev/netif/ath/ath/if_athvar.h
@@ -633,8 +633,7 @@ struct ath_softc {
 				sc_resetcal : 1,/* reset cal state next trip */
 				sc_rxslink  : 1,/* do self-linked final descriptor */
 				sc_rxtsf32  : 1,/* RX dec TSF is 32 bits */
-				sc_isedma   : 1,/* supports EDMA */
-				sc_do_mybeacon : 1; /* supports mybeacon */
+				sc_isedma   : 1;/* supports EDMA */
 
 	/*
 	 * Second set of flags.
@@ -881,22 +880,6 @@ struct ath_softc {
 	void			(*sc_bar_response)(struct ieee80211_node *ni,
 				    struct ieee80211_tx_ampdu *tap,
 				    int status);
-
-	/*
-	 * Powersave state tracking.
-	 *
-	 * target/cur powerstate is the chip power state.
-	 * target selfgen state is the self-generated frames
-	 *   state.  The chip can be awake but transmitted frames
-	 *   can have the PWRMGT bit set to 1 so the destination
-	 *   thinks the node is asleep.
-	 */
-	HAL_POWER_MODE		sc_target_powerstate;
-	HAL_POWER_MODE		sc_target_selfgen_state;
-
-	HAL_POWER_MODE		sc_cur_powerstate;
-
-	int			sc_powersave_refcnt;
 };
 
 #define	ATH_LOCK_INIT(_sc)
@@ -1019,8 +1002,6 @@ void	ath_intr(void *);
 	((*(_ah)->ah_updateTxTrigLevel)((_ah), (_inc)))
 #define	ath_hal_setpower(_ah, _mode) \
 	((*(_ah)->ah_setPowerMode)((_ah), (_mode), AH_TRUE))
-#define	ath_hal_setselfgenpower(_ah, _mode) \
-	((*(_ah)->ah_setPowerMode)((_ah), (_mode), AH_FALSE))
 #define	ath_hal_keycachesize(_ah) \
 	((*(_ah)->ah_getKeyCacheSize)((_ah)))
 #define	ath_hal_keyreset(_ah, _ix) \
@@ -1249,8 +1230,6 @@ void	ath_intr(void *);
 #define	ath_hal_setintmit(_ah, _v) \
 	ath_hal_setcapability(_ah, HAL_CAP_INTMIT, \
 	HAL_CAP_INTMIT_ENABLE, _v, NULL)
-#define	ath_hal_hasmybeacon(_ah) \
-	(ath_hal_getcapability(_ah, HAL_CAP_DO_MYBEACON, 1, NULL) == HAL_OK)
 
 #define	ath_hal_hasenforcetxop(_ah) \
 	(ath_hal_getcapability(_ah, HAL_CAP_ENFORCE_TXOP, 0, NULL) == HAL_OK)
diff --git a/sys/dev/netif/ath/ath_hal/ah.c b/sys/dev/netif/ath/ath_hal/ah.c
index bbfc09b..7187d57 100644
--- a/sys/dev/netif/ath/ath_hal/ah.c
+++ b/sys/dev/netif/ath/ath_hal/ah.c
@@ -786,8 +786,6 @@ ath_hal_getcapability(struct ath_hal *ah, HAL_CAPABILITY_TYPE type,
 		return HAL_OK;
 	case HAL_CAP_RX_LNA_MIXING:	/* Hardware uses an RX LNA mixer to map 2 antennas to a 1 stream receiver */
 		return pCap->halRxUsingLnaMixing ? HAL_OK : HAL_ENOTSUPP;
-	case HAL_CAP_DO_MYBEACON:	/* Hardware supports filtering my-beacons */
-		return pCap->halRxDoMyBeacon ? HAL_OK : HAL_ENOTSUPP;
 	default:
 		return HAL_EINVAL;
 	}
diff --git a/sys/dev/netif/ath/ath_hal/ah.h b/sys/dev/netif/ath/ath_hal/ah.h
index 4f2d3e9..2480803 100644
--- a/sys/dev/netif/ath/ath_hal/ah.h
+++ b/sys/dev/netif/ath/ath_hal/ah.h
@@ -199,7 +199,6 @@ typedef enum {
 	HAL_CAP_SERIALISE_WAR	= 245,	/* serialise register access on PCI */
 	HAL_CAP_ENFORCE_TXOP	= 246,	/* Enforce TXOP if supported */
 	HAL_CAP_RX_LNA_MIXING	= 247,	/* RX hardware uses LNA mixing */
-	HAL_CAP_DO_MYBEACON	= 248,	/* Supports HAL_RX_FILTER_MYBEACON */
 } HAL_CAPABILITY_TYPE;
 
 /* 
@@ -405,7 +404,6 @@ typedef enum {
 	HAL_RX_FILTER_PROM	= 0x00000020,	/* Promiscuous mode */
 	HAL_RX_FILTER_PROBEREQ	= 0x00000080,	/* Allow probe request frames */
 	HAL_RX_FILTER_PHYERR	= 0x00000100,	/* Allow phy errors */
-	HAL_RX_FILTER_MYBEACON  = 0x00000200,   /* Filter beacons other than mine */
 	HAL_RX_FILTER_COMPBAR	= 0x00000400,	/* Allow compressed BAR */
 	HAL_RX_FILTER_COMP_BA	= 0x00000800,	/* Allow compressed blockack */
 	HAL_RX_FILTER_PHYRADAR	= 0x00002000,	/* Allow phy radar errors */
@@ -1299,9 +1297,6 @@ struct ath_hal {
 	uint32_t	ah_intrstate[8];	/* last int state */
 	uint32_t	ah_syncstate;		/* last sync intr state */
 
-	/* Current powerstate from HAL calls */
-	HAL_POWER_MODE	ah_powerMode;
-
 	HAL_OPS_CONFIG ah_config;
 	const HAL_RATE_TABLE *__ahdecl(*ah_getRateTable)(struct ath_hal *,
 				u_int mode);
diff --git a/sys/dev/netif/ath/ath_hal/ah_internal.h b/sys/dev/netif/ath/ath_hal/ah_internal.h
index 460c138..331093b 100644
--- a/sys/dev/netif/ath/ath_hal/ah_internal.h
+++ b/sys/dev/netif/ath/ath_hal/ah_internal.h
@@ -280,8 +280,7 @@ typedef struct {
 			halAntDivCombSupportOrg		: 1,
 			halRadioRetentionSupport	: 1,
 			halSpectralScanSupport		: 1,
-			halRxUsingLnaMixing		: 1,
-			halRxDoMyBeacon			: 1;
+			halRxUsingLnaMixing		: 1;
 
 	uint32_t	halWirelessModes;
 	uint16_t	halTotalQueues;
diff --git a/sys/dev/netif/ath/ath_hal/ah_osdep.c b/sys/dev/netif/ath/ath_hal/ah_osdep.c
index e5b27dd..75e8967 100644
--- a/sys/dev/netif/ath/ath_hal/ah_osdep.c
+++ b/sys/dev/netif/ath/ath_hal/ah_osdep.c
@@ -149,24 +149,6 @@ ath_hal_ether_sprintf(const u_int8_t *mac)
 
 #ifdef AH_DEBUG
 
-/*
- * XXX This is highly relevant only for the AR5416 and later
- * PCI/PCIe NICs.  It'll need adjustment for other hardware
- * variations.
- */
-static int
-ath_hal_reg_whilst_asleep(struct ath_hal *ah, uint32_t reg)
-{
-
-	if (reg >= 0x4000 && reg < 0x5000)
-		return (1);
-	if (reg >= 0x6000 && reg < 0x7000)
-		return (1);
-	if (reg >= 0x7000 && reg < 0x8000)
-		return (1);
-	return (0);
-}
-
 void
 DO_HALDEBUG(struct ath_hal *ah, u_int mask, const char* fmt, ...)
 {
@@ -281,13 +263,6 @@ ath_hal_reg_write(struct ath_hal *ah, u_int32_t reg, u_int32_t val)
 	bus_space_tag_t tag = BUSTAG(ah);
 	bus_space_handle_t h = ah->ah_sh;
 
-	/* Debug - complain if we haven't fully waken things up */
-	if (! ath_hal_reg_whilst_asleep(ah, reg) &&
-	    ah->ah_powerMode != HAL_PM_AWAKE) {
-		ath_hal_printf(ah, "%s: reg=0x%08x, val=0x%08x, pm=%d\n",
-		    __func__, reg, val, ah->ah_powerMode);
-	}
-
 	if (ath_hal_alq) {
 		struct ale *ale = ath_hal_alq_get(ah);
 		if (ale) {
@@ -313,13 +288,6 @@ ath_hal_reg_read(struct ath_hal *ah, u_int32_t reg)
 	bus_space_handle_t h = ah->ah_sh;
 	u_int32_t val;
 
-	/* Debug - complain if we haven't fully waken things up */
-	if (! ath_hal_reg_whilst_asleep(ah, reg) &&
-	    ah->ah_powerMode != HAL_PM_AWAKE) {
-		ath_hal_printf(ah, "%s: reg=0x%08x, pm=%d\n",
-		    __func__, reg, ah->ah_powerMode);
-	}
-
 	if (ah->ah_config.ah_serialise_reg_war)
 		spin_lock(&ah_regser_spin);
 	val = bus_space_read_4(tag, h, reg);
@@ -372,20 +340,6 @@ ath_hal_reg_write(struct ath_hal *ah, u_int32_t reg, u_int32_t val)
 	bus_space_tag_t tag = BUSTAG(ah);
 	bus_space_handle_t h = ah->ah_sh;
 
-	/* Debug - complain if we haven't fully waken things up */
-	if (! ath_hal_reg_whilst_asleep(ah, reg) &&
-	    ah->ah_powerMode != HAL_PM_AWAKE) {
-		ath_hal_printf(ah, "%s: reg=0x%08x, val=0x%08x, pm=%d\n",
-		    __func__, reg, val, ah->ah_powerMode);
-	}
-
-	/* Debug - complain if we haven't fully waken things up */
-	if (! ath_hal_reg_whilst_asleep(ah, reg) &&
-	    ah->ah_powerMode != HAL_PM_AWAKE) {
-		ath_hal_printf(ah, "%s: reg=0x%08x, pm=%d\n",
-		    __func__, reg, ah->ah_powerMode);
-	}
-
 	if (ah->ah_config.ah_serialise_reg_war)
 		spin_lock(&ah_regser_spin);
 	bus_space_write_4(tag, h, reg, val);
diff --git a/sys/dev/netif/ath/ath_hal/ah_regdomain.c b/sys/dev/netif/ath/ath_hal/ah_regdomain.c
index c699448..e871cd7 100644
--- a/sys/dev/netif/ath/ath_hal/ah_regdomain.c
+++ b/sys/dev/netif/ath/ath_hal/ah_regdomain.c
@@ -169,11 +169,6 @@ isEepromValid(struct ath_hal *ah)
 			if (regDomainPairs[i].regDmnEnum == rd)
 				return AH_TRUE;
 	}
-
-	if (rd == FCC_UBNT) {
-		return AH_TRUE;
-	}
-
 	HALDEBUG(ah, HAL_DEBUG_REGDOMAIN,
 	    "%s: invalid regulatory domain/country code 0x%x\n", __func__, rd);
 	return AH_FALSE;
